# Projet_CR

## Description

Ce projet entre dans le cadre du cours de connaissances et raisonnement de la mention IA.
L'objectif du projet est dans un premier temps de réaliser un solveur du jeu Queens de Linkedin puis dans un deuxième temps
de pouvoir générer des grilles de tailles variables afin de pouvoir jouer au jeu de manière illimité.

### Principe du jeu

Le jeu consiste à placer sur une grille, des couronnes de manières à respecter la liste de règles suivante:

- Il doit y avoir une et une seule couronne par ligne
- Il doit y avoir une et une seule couronne par colonne
- Il doit y avoir une et une seule couronne sur chaque plage de couleur
- Deux couronnes ne peuvent pas être voisines (sur les côtés ou en diagonale)

Pour plus d'informations, veuillez visiter la page officielle du jeu: https://www.linkedin.com/games/queens

### Exemple grille vierge
![alt text](image.png)  

### Solution fournie par le solveur
![alt text](image-1.png)

Les cercles correspondent aux emplacements des couronnes

## Requirements

Ce projet utilise le solveur Gophersat: https://github.com/crillab/gophersat

Bibliothèque utilisées:
- Numpy
- Random
- Subprocess
- matplotlib

## Fonctionnement

Placer gophersat à la racine du projet ou modifier path_to_gophersat.
Les Fonctions utiles sont dans utils/utils.py

Pour lancer le programme executer le script projet_couronnes.py